#pragma once

#include "Generic.h"

typedef struct
{
    /* Идентификатор процесса */
    UINT32 Pid;
    /* Адрес, по которому загружен модуль */
    PVOID BaseAddr;
    /* Относительный виртуальный адрес секции */
    UINT32 RVA;
    /* Имя секции */
    UINT8 Name[8];
    /* CRC секции */
    UINT32 CRC32;
    /* Указатель на следующий элемент списка */
    LIST_ENTRY Next;
    /* Вспомогательная переменная для очистки списка от выгруженных модулей */
    UINT32 IsPresent;
} SectionList, * pSectionList;


void InitList(PLIST_ENTRY Head);
void AddEntry(PLIST_ENTRY Head, UINT32 Pid, PVOID BaseAddr, UINT32 RVA, const PUINT8 Name, UINT32 CRC32);
void DeleteEntry(PLIST_ENTRY Head, UINT32 Pid, PVOID BaseAddr, UINT32 RVA, const PUINT8 Name, UINT32 CRC32);
pSectionList FindEntry(PLIST_ENTRY Head, UINT32 Pid, PVOID BaseAddr, UINT32 RVA, const PUINT8 Name);
void CleanList(PLIST_ENTRY Head);
void ShowList(PLIST_ENTRY Head);
void DeleteUnusedEntries(PLIST_ENTRY Head, UINT32 Pid);
void ZeroIsPresent(PLIST_ENTRY Head, UINT32 Pid);
